include masm32rt.inc
include msimg32.inc
includelib msimg32.lib
.686p
.mmx
.xmm

WndProc 	proto :DWORD,:DWORD,:DWORD,:DWORD

.data?
    hInstance	DWORD ?
    hDcBuffer	DWORD ?   ; back buffer -> double buffering. Only valid if bDrag!=0
    hDcDrawing	DWORD ?   ; our drawing
    hDcPreview	DWORD ?   ; preview DC. Only Valid if bDrag!=0

    hBmpBuffer	HBITMAP ? ;  save bitmap handles for deletion
    hBmpDrawing	HBITMAP ? ;
    hBmpPreview HBITMAP ? ;

    pt			POINT <>
    bDrag		DWORD ?   ; user drags?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

    mov hInstance,rv(GetModuleHandle,0)
    mov wcex.hInstance,eax
    mov wcex.cbSize,SIZEOF WNDCLASSEX
    mov wcex.style, CS_HREDRAW or CS_VREDRAW
    mov wcex.lpfnWndProc, OFFSET WndProc
    mov wcex.cbClsExtra,NULL
    mov wcex.cbWndExtra,0
    mov wcex.hbrBackground,0
    mov wcex.lpszMenuName,NULL
    mov wcex.lpszClassName,chr$("Win32GDI")
    mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
    mov wcex.hIconSm,eax
    mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
    invoke RegisterClassEx, ADDR wcex
    mov esi,rv(CreateWindowEx,NULL,wcex.lpszClassName,"what ever",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL)
    invoke ShowWindow,esi,SW_SHOWNORMAL
    invoke UpdateWindow,esi

    .while 1
        invoke GetMessage,ADDR msg,NULL,0,0
        .break .if !eax || eax == -1
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
    .endw

    invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL hBr:HBRUSH
LOCAL rect:RECT

    .if uMsg == WM_CLOSE
        invoke PostQuitMessage,NULL
    .elseif uMsg == WM_DESTROY
        invoke DeleteObject,rv(SelectObject,hDcDrawing,hBmpDrawing)
        invoke DeleteDC,hDcDrawing
    .elseif uMsg == WM_CREATE
    
        ; create DC, that holds our drawing
        mov esi,rv(GetDC,rv(GetDesktopWindow))
        mov hDcDrawing,rv(CreateCompatibleDC,esi)
        mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
        mov hBmpDrawing,rv(SelectObject,hDcDrawing,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
        invoke ReleaseDC,rv(GetDesktopWindow),esi
        invoke BitBlt,hDcDrawing,0,0,10000,10000,hDcDrawing,0,0,PATCOPY
        
    .elseif uMsg == WM_LBUTTONDOWN
        .if !bDrag
            mov bDrag,1
            invoke SetCapture,hWnd
            
            movzx eax,WORD ptr lParam
            movzx edx,WORD ptr lParam+2
            mov pt.x,eax
            mov pt.y,edx
            
            ; create DC used for drawing the preview
            mov esi,rv(GetDC,rv(GetDesktopWindow))
            mov hDcPreview,rv(CreateCompatibleDC,esi)
            mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
            mov hBmpPreview,rv(SelectObject,hDcPreview,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
            invoke ReleaseDC,rv(GetDesktopWindow),esi	

            ;  double buffering: create buffer -> this avoids flickering
            mov esi,rv(GetDC,rv(GetDesktopWindow))
            mov hDcBuffer,rv(CreateCompatibleDC,esi)
            invoke GetClientRect,hWnd,ADDR rect
            mov hBmpBuffer,rv(SelectObject,hDcBuffer,rv(CreateCompatibleBitmap,esi,rect.right,rect.bottom))
            invoke ReleaseDC,rv(GetDesktopWindow),esi

            ; clear preview-DC with transparent color - each pixel having this color, won't
            ; copied by TransparentBlt().
            mov hBr,rv(SelectObject,hDcPreview,rv(CreateSolidBrush,0ff00ffh))
            invoke BitBlt,hDcPreview,0,0,10000,10000,hDcPreview,0,0,PATCOPY
            invoke DeleteObject,rv(SelectObject,hDcPreview,hBr)
        .endif
    .elseif uMsg == WM_MOUSEMOVE
        .if bDrag

            ; get current rectangle
            movsx eax,WORD ptr lParam
            movsx edx,WORD ptr lParam+2
            .if pt.x < SDWORD ptr eax
                m2m rect.left,pt.x
                mov rect.right,eax
            .else
                mov rect.left,eax
                m2m rect.right,pt.x
            .endif
            .if pt.y < SDWORD ptr edx
                m2m rect.top,pt.y
                mov rect.bottom,edx
            .else
                mov rect.top,edx
                m2m rect.bottom,pt.y
            .endif
            
            ; clear preview-DC with transparent color
            mov hBr,rv(SelectObject,hDcPreview,rv(CreateSolidBrush,0ff00ffh))
            invoke BitBlt,hDcPreview,0,0,10000,10000,hDcPreview,0,0,PATCOPY
            invoke DeleteObject,rv(SelectObject,hDcPreview,hBr)
            
            ; draw preview-rectangle (color=red)
            mov hBr,rv(SelectObject,hDcPreview,rv(CreateSolidBrush,0ffh))
            invoke Rectangle,hDcPreview,rect.left,rect.top,rect.right,rect.bottom
            invoke DeleteObject,rv(SelectObject,hDcPreview,hBr)
            
            invoke InvalidateRect,hWnd,0,0
        .endif
    .elseif uMsg == WM_LBUTTONUP
        .if bDrag
            ; dragging is finished
            mov bDrag,0
            invoke ReleaseCapture
            
            mov esi,rv(GetSystemMetrics,SM_CXSCREEN)
            mov edi,rv(GetSystemMetrics,SM_CYSCREEN)
            ; merge preview with drawing
            invoke TransparentBlt,hDcDrawing,0,0,esi,edi,hDcPreview,0,0,esi,edi,0ff00ffh
    
    		; delete bitmaps
    		invoke DeleteObject,rv(SelectObject,hDcPreview,hBmpPreview)
    		invoke DeleteObject,rv(SelectObject,hDcBuffer,hBmpBuffer)
    		
            ; delete DC's
            invoke DeleteDC,hDcPreview
            invoke DeleteDC,hDcBuffer
            
            invoke InvalidateRect,hWnd,0,0
        .endif
    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWnd,ADDR ps
        
        ; if no preview is needed, we can directly copy our drawing to the screen
        .if !bDrag
            mov edx,ps.rcPaint.right
            sub edx,ps.rcPaint.left
            mov ecx,ps.rcPaint.bottom
            sub ecx,ps.rcPaint.top
            invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hDcDrawing,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        .else ; preview nedded (mouse is dragging)
            ; copy drawing to buffer
            mov edx,ps.rcPaint.right
            sub edx,ps.rcPaint.left
            mov ecx,ps.rcPaint.bottom
            sub ecx,ps.rcPaint.top
            invoke BitBlt,hDcBuffer,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hDcDrawing,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY

            ; draw preview to buffer
            mov edx,ps.rcPaint.right
            sub edx,ps.rcPaint.left
            mov ecx,ps.rcPaint.bottom
            sub ecx,ps.rcPaint.top
            invoke TransparentBlt,hDcBuffer,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hDcPreview,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,0ff00ffh

            ; copy buffer to screen
            mov edx,ps.rcPaint.right
            sub edx,ps.rcPaint.left
            mov ecx,ps.rcPaint.bottom
            sub ecx,ps.rcPaint.top
            invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hDcBuffer,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        .endif
        invoke EndPaint,hWnd,ADDR ps	
    .else
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif

    xor eax,eax
    ret
WndProc endp
end main
